* Create the "level 1" cursor of sales by product.

close all
open database \VFP5\SAMPLES\DATA\TESTDATA
select padr(PRODUCTS.PROD_NAME, 40) as NAME, ;
		PRODUCTS.PROD_NAME, ;
		1 as LEVEL, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1993, ORDERS.ORDER_AMT, 00000000.00)) as SALES93, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1994, ORDERS.ORDER_AMT, 00000000.00)) as SALES94, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1995, ORDERS.ORDER_AMT, 00000000.00)) as SALES95, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1996, ORDERS.ORDER_AMT, 00000000.00)) as SALES96, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1993, ORDITEMS.QUANTITY, 000000))     as QTY93, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1994, ORDITEMS.QUANTITY, 000000))     as QTY94, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1995, ORDITEMS.QUANTITY, 000000))     as QTY95, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1996, ORDITEMS.QUANTITY, 000000))     as QTY96 ;
	from PRODUCTS, ORDITEMS, ORDERS ;
	where PRODUCTS.PRODUCT_ID = ORDITEMS.PRODUCT_ID and ;
		ORDITEMS.ORDER_ID = ORDERS.ORDER_ID ;
	into cursor SALES1 ;
	group by 2

* Create the "level 2" cursor of sales by product and employee.

select padr(trim(EMPLOYEE.LAST_NAME) + ', ' + EMPLOYEE.FIRST_NAME, 40) as NAME, ;
		PRODUCTS.PROD_NAME, ;
		padr(trim(EMPLOYEE.LAST_NAME) + ', ' + EMPLOYEE.FIRST_NAME, 40) as EMP_NAME, ;
		2 as LEVEL, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1993, ORDERS.ORDER_AMT, 00000000.00)) as SALES93, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1994, ORDERS.ORDER_AMT, 00000000.00)) as SALES94, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1995, ORDERS.ORDER_AMT, 00000000.00)) as SALES95, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1996, ORDERS.ORDER_AMT, 00000000.00)) as SALES96, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1993, ORDITEMS.QUANTITY, 000000))     as QTY93, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1994, ORDITEMS.QUANTITY, 000000))     as QTY94, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1995, ORDITEMS.QUANTITY, 000000))     as QTY95, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1996, ORDITEMS.QUANTITY, 000000))     as QTY96 ;
	from PRODUCTS, ORDITEMS, ORDERS, EMPLOYEE ;
	where PRODUCTS.PRODUCT_ID = ORDITEMS.PRODUCT_ID and ;
		ORDITEMS.ORDER_ID = ORDERS.ORDER_ID and ;
		ORDERS.EMP_ID = EMPLOYEE.EMP_ID ;
	into cursor SALES2 ;
	group by 2, 3

* Create the "level 3" cursor of sales by product, employee, and country.

select padr(CUSTOMER.COUNTRY, 40) as NAME, ;
		PRODUCTS.PROD_NAME, ;
		padr(trim(EMPLOYEE.LAST_NAME) + ', ' + EMPLOYEE.FIRST_NAME, 40) as EMP_NAME, ;
		CUSTOMER.COUNTRY, ;
		3 as LEVEL, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1993, ORDERS.ORDER_AMT, 00000000.00)) as SALES93, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1994, ORDERS.ORDER_AMT, 00000000.00)) as SALES94, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1995, ORDERS.ORDER_AMT, 00000000.00)) as SALES95, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1996, ORDERS.ORDER_AMT, 00000000.00)) as SALES96, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1993, ORDITEMS.QUANTITY, 000000))     as QTY93, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1994, ORDITEMS.QUANTITY, 000000))     as QTY94, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1995, ORDITEMS.QUANTITY, 000000))     as QTY95, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1996, ORDITEMS.QUANTITY, 000000))     as QTY96 ;
	from PRODUCTS, ORDITEMS, ORDERS, EMPLOYEE, CUSTOMER ;
	where PRODUCTS.PRODUCT_ID = ORDITEMS.PRODUCT_ID and ;
		ORDITEMS.ORDER_ID = ORDERS.ORDER_ID and ;
		ORDERS.EMP_ID = EMPLOYEE.EMP_ID and ;
		ORDERS.CUST_ID = CUSTOMER.CUST_ID ;
	into cursor SALES3 ;
	group by 2, 3, 4

* Create the "level 4" cursor of sales by product, employee, country, and
* customer, but put it into a table.

select padr(CUSTOMER.COMPANY, 40) as NAME, ;
		PRODUCTS.PROD_NAME, ;
		padr(trim(EMPLOYEE.LAST_NAME) + ', ' + EMPLOYEE.FIRST_NAME, 40) as EMP_NAME, ;
		CUSTOMER.COUNTRY, ;
		4 as LEVEL, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1993, ORDERS.ORDER_AMT, 00000000.00)) as SALES93, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1994, ORDERS.ORDER_AMT, 00000000.00)) as SALES94, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1995, ORDERS.ORDER_AMT, 00000000.00)) as SALES95, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1996, ORDERS.ORDER_AMT, 00000000.00)) as SALES96, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1993, ORDITEMS.QUANTITY, 000000))     as QTY93, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1994, ORDITEMS.QUANTITY, 000000))     as QTY94, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1995, ORDITEMS.QUANTITY, 000000))     as QTY95, ;
		sum(iif(year(ORDERS.ORDER_DATE) = 1996, ORDITEMS.QUANTITY, 000000))     as QTY96 ;
	from PRODUCTS, ORDITEMS, ORDERS, EMPLOYEE, CUSTOMER ;
	where PRODUCTS.PRODUCT_ID = ORDITEMS.PRODUCT_ID and ;
		ORDITEMS.ORDER_ID = ORDERS.ORDER_ID and ;
		ORDERS.EMP_ID = EMPLOYEE.EMP_ID and ;
		ORDERS.CUST_ID = CUSTOMER.CUST_ID ;
	into tables SALES ;
	group by 2, 3, 4, 1

* Append all the cursors into the sales table.

append from dbf('SALES1')
append from dbf('SALES2')
append from dbf('SALES3')
index on deleted() tag DELETED
index on upper(PROD_NAME + EMP_NAME + COUNTRY + str(LEVEL, 1) + NAME) tag SALES

* Sum only level 1 records to memory variables.

sum SALES93, SALES94, SALES95, SALES96, QTY93, QTY94, QTY95, QTY96 to ;
	SALES93, SALES94, SALES95, SALES96, QTY93, QTY94, QTY95, QTY96 ;
	for LEVEL = 1

* Update the values for other fields to be inserted into a new record for
* grand totals.

NAME       = 'Totals'
LEVEL      = 0
SORT       = 'ZZZZZ'
PROD_NAME  = 'ZZZZZ'
EMP_NAME   = 'ZZZZZ'
COUNTRY    = 'ZZZZZ'
insert into SALES from memvar
return
