#include FOXPRO.H
set talk off

* Create an instance of the DrillDownForm class into a public variable so it
* exists when this program is done.

close all
public oSales
set classlib to DRILLDWN
oSales = createobject('DrillDownForm')
with oSales

* Initialize the properties containing the name and order of the data table and
* set up the data for the drill down.

	.cTable = 'SALES'
	.cOrder = 'SALES'
	.SetupData()

* Initialize the levels and level keys we need.

	.nMaxLevels = 3
	dimension .aLevelKey[.nMaxLevels]
	.aLevelKey[1] = 'PROD_NAME'
	.aLevelKey[2] = 'EMP_NAME'
	.aLevelKey[3] = 'COUNTRY'

* Initialize color settings (this might come from a table of user preferences
* or Registry keys).

	dimension .aColorLevel[.nMaxLevels + 2]
	.aColorLevel[1] = COLOR_RED
	.aColorLevel[2] = COLOR_BLACK
	.aColorLevel[3] = COLOR_BLUE
	.aColorLevel[4] = COLOR_GREEN
	.aColorLevel[5] = COLOR_MAGENTA

* Create grid columns we want to display.

	.AddGridColumn('lv_sales.sales93', '93 Sales')
	.AddGridColumn('lv_sales.sales94', '94 Sales')
	.AddGridColumn('lv_sales.sales95', '95 Sales')
	.AddGridColumn('lv_sales.sales96', '96 Sales')
	.AddGridColumn('lv_sales.qty93',   '93 Qty')
	.AddGridColumn('lv_sales.qty94',   '94 Qty')
	.AddGridColumn('lv_sales.qty95',   '95 Qty')
	.AddGridColumn('lv_sales.qty96',   '96 Qty')
endwith

* Display the drill down form.

oSales.Show()
